Index: src/Actions/unittests/stubs/DummyUI.hpp
===================================================================
--- src/Actions/unittests/stubs/DummyUI.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/Actions/unittests/stubs/DummyUI.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -28,4 +28,5 @@
   virtual void queryInts(const char *, std::string = ""){}
   virtual void queryUnsignedInt(const char *, std::string = ""){}
+  virtual void queryUnsignedInts(const char *, std::string = ""){}
   virtual void queryString(const char*, std::string = ""){}
   virtual void queryStrings(const char*, std::string = ""){}
Index: src/UIElements/CommandLineUI/CommandLineDialog.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/CommandLineDialog.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -50,4 +50,8 @@
 void CommandLineDialog::queryUnsignedInt(const char* title, string _description){
   registerQuery(new UnsignedIntCommandLineQuery(title, _description));
+}
+
+void CommandLineDialog::queryUnsignedInts(const char* title, string _description){
+  registerQuery(new UnsignedIntsCommandLineQuery(title, _description));
 }
 
Index: src/UIElements/CommandLineUI/CommandLineDialog.hpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/CommandLineDialog.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -37,4 +37,5 @@
   virtual void queryInts(const char *, std::string = "");
   virtual void queryUnsignedInt(const char *, std::string = "");
+  virtual void queryUnsignedInts(const char *, std::string = "");
   virtual void queryBoolean(const char *, std::string = "");
   virtual void queryString(const char*, std::string = "");
@@ -74,4 +75,5 @@
   class StringsCommandLineQuery;
   class UnsignedIntCommandLineQuery;
+  class UnsignedIntsCommandLineQuery;
   class VectorCommandLineQuery;
   class VectorsCommandLineQuery;
Index: src/UIElements/CommandLineUI/CommandLineParser.cpp
===================================================================
--- src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/CommandLineParser.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -240,4 +240,13 @@
                   po::value < unsigned int >()->default_value(boost::lexical_cast<unsigned int>(currentOption->getDefaultValue().c_str())) :
                   po::value < unsigned int >(),
+                  currentOption->getDescription().c_str())
+        ;
+      break;
+    case TypeEnumContainer::ListOfUnsignedIntegersType:
+      OptionList->add_options()
+        (currentOption->getKeyAndShortForm().c_str(),
+//            currentOption->hasDefaultValue() ?
+//                  po::value < std::vector<unsigned int> >()->default_value(boost::lexical_cast< std::vector<unsigned int> >(currentOption->getDefaultValue().c_str())) :
+                  po::value < std::vector<unsigned int> >()->multitoken(),
                   currentOption->getDescription().c_str())
         ;
Index: src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp
===================================================================
--- src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/Query/CommandLineQuery.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -42,4 +42,11 @@
   UnsignedIntCommandLineQuery(std::string title, std::string _description = "");
   virtual ~UnsignedIntCommandLineQuery();
+  virtual bool handle();
+};
+
+class CommandLineDialog::UnsignedIntsCommandLineQuery : public Dialog::UnsignedIntsQuery {
+public:
+  UnsignedIntsCommandLineQuery(std::string title, std::string _description = "");
+  virtual ~UnsignedIntsCommandLineQuery();
   virtual bool handle();
 };
Index: src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp
===================================================================
--- src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
+++ src/UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -0,0 +1,42 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UnsignedIntsCommandLineQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "CommandLineUI/Query/CommandLineQuery.hpp"
+#include "CommandLineUI/CommandLineParser.hpp"
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+CommandLineDialog::UnsignedIntsCommandLineQuery::UnsignedIntsCommandLineQuery(string title, string _description) :
+    Dialog::UnsignedIntsQuery(title, _description)
+{}
+
+CommandLineDialog::UnsignedIntsCommandLineQuery::~UnsignedIntsCommandLineQuery() {}
+
+bool CommandLineDialog::UnsignedIntsCommandLineQuery::handle() {
+  if (CommandLineParser::getInstance().vm.count(getTitle())) {
+    tmp = CommandLineParser::getInstance().vm[getTitle()].as< std::vector<unsigned int> >();
+    return true;
+  } else {
+    DoeLog(1) && (eLog() << Verbose(1) << "CommandLineUI parsing error: Missing integers for " << getTitle() << "." << endl);
+    return false;
+  }
+}
+
Index: src/UIElements/CommandLineUI/TypeEnumContainer.cpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -53,4 +53,5 @@
   TypeEnumMap[&typeid(std::vector<int>)] = ListOfIntegersType;
   TypeEnumMap[&typeid(unsigned int)] = UnsignedIntegerType;
+  TypeEnumMap[&typeid(std::vector<unsigned int>)] = ListOfUnsignedIntegersType;
   TypeEnumMap[&typeid(double)] = DoubleType;
   TypeEnumMap[&typeid(std::vector<double>)] = ListOfDoublesType;
Index: src/UIElements/CommandLineUI/TypeEnumContainer.hpp
===================================================================
--- src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/CommandLineUI/TypeEnumContainer.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -34,4 +34,5 @@
         ListOfIntegersType,
         UnsignedIntegerType,
+        ListOfUnsignedIntegersType,
         DoubleType,
         ListOfDoublesType,
Index: src/UIElements/Dialog.cpp
===================================================================
--- src/UIElements/Dialog.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Dialog.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -111,4 +111,9 @@
 }
 
+template <> void Dialog::query< std::vector<unsigned int> >(const char *token, std::string description)
+{
+  queryUnsignedInts(token, description);
+}
+
 template <> void Dialog::query<double>(const char *token, std::string description)
 {
Index: src/UIElements/Dialog.hpp
===================================================================
--- src/UIElements/Dialog.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Dialog.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -138,4 +138,5 @@
  *   -# add CommandLineDialog::query...(), TextDialog::query...(), and QtDialog::query...(),
  *      i.e. for each of the three interface
+ *   -# add empty definition DummyDialog::query...() to the stub for Action unittests in DummUI.hpp.
  *   -# add Dialog::...Query class with tmp value of desired type
  *   -# add CommandLineDialog::...Query, TextDialog::...Query, QtDialog::...Query
@@ -161,4 +162,5 @@
   virtual void queryInts(const char *, std::string = "")=0;
   virtual void queryUnsignedInt(const char *, std::string = "")=0;
+  virtual void queryUnsignedInts(const char *, std::string = "")=0;
   virtual void queryDouble(const char*, std::string = "")=0;
   virtual void queryDoubles(const char*, std::string = "")=0;
@@ -287,4 +289,15 @@
   };
 
+  class UnsignedIntsQuery : public Query {
+  public:
+    UnsignedIntsQuery(std::string title, std::string _description = "");
+    virtual ~UnsignedIntsQuery();
+    virtual bool handle()=0;
+    virtual void setResult();
+  protected:
+    unsigned int temp;
+    std::vector<unsigned int> tmp;
+  };
+
   class DoubleQuery : public Query {
   public:
Index: src/UIElements/Makefile.am
===================================================================
--- src/UIElements/Makefile.am	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Makefile.am	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -19,4 +19,5 @@
   UIElements/CommandLineUI/Query/StringsCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/UnsignedIntCommandLineQuery.cpp \
+  UIElements/CommandLineUI/Query/UnsignedIntsCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/VectorCommandLineQuery.cpp \
   UIElements/CommandLineUI/Query/VectorsCommandLineQuery.cpp \
@@ -87,4 +88,5 @@
   UIElements/TextUI/Query/StringsTextQuery.cpp \
   UIElements/TextUI/Query/UnsignedIntTextQuery.cpp \
+  UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp \
   UIElements/TextUI/Query/VectorTextQuery.cpp \
   UIElements/TextUI/Query/VectorsTextQuery.cpp \
@@ -137,4 +139,5 @@
   UIElements/Query/StringsQuery.cpp \
   UIElements/Query/UnsignedIntQuery.cpp \
+  UIElements/Query/UnsignedIntsQuery.cpp \
   UIElements/Query/VectorQuery.cpp \
   UIElements/Query/VectorsQuery.cpp \
@@ -186,4 +189,5 @@
   UIElements/Qt4/Query/StringsQtQuery.cpp \
   UIElements/Qt4/Query/UnsignedIntQtQuery.cpp \
+  UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp \
   UIElements/Qt4/Query/VectorQtQuery.cpp \
   UIElements/Qt4/Query/VectorsQtQuery.cpp \
Index: src/UIElements/Qt4/QtDialog.cpp
===================================================================
--- src/UIElements/Qt4/QtDialog.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/QtDialog.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -115,4 +115,9 @@
 }
 
+void QtDialog::queryUnsignedInts(const char *title,string)
+{
+  registerQuery(new UnsignedIntsQtQuery(title,inputLayout,this));
+}
+
 void QtDialog::queryDouble(const char* title,string)
 {
Index: src/UIElements/Qt4/QtDialog.hpp
===================================================================
--- src/UIElements/Qt4/QtDialog.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/QtDialog.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -37,4 +37,5 @@
   virtual void queryInts(const char *,std::string = "");
   virtual void queryUnsignedInt(const char *,std::string = "");
+  virtual void queryUnsignedInts(const char *,std::string = "");
   virtual void queryDouble(const char*,std::string = "");
   virtual void queryDoubles(const char*,std::string = "");
@@ -75,4 +76,5 @@
   class StringsQtQuery;
   class UnsignedIntQtQuery;
+  class UnsignedIntsQtQuery;
   class VectorQtQuery;
   class VectorsQtQuery;
Index: src/UIElements/Qt4/Query/QtQuery.hpp
===================================================================
--- src/UIElements/Qt4/Query/QtQuery.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/Qt4/Query/QtQuery.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -48,4 +48,5 @@
 class StringsQtQueryPipe;
 class UnsignedIntQtQueryPipe;
+class UnsignedIntsQtQueryPipe;
 class VectorQtQueryPipe;
 class VectorsQtQueryPipe;
@@ -294,4 +295,22 @@
 };
 
+class QtDialog::UnsignedIntsQtQuery : public Dialog::UnsignedIntsQuery {
+public:
+  UnsignedIntsQtQuery(std::string _title,QBoxLayout *_parent,QtDialog *_dialog);
+  virtual ~UnsignedIntsQtQuery();
+  virtual bool handle();
+  void IntegerEntered(const QString&);
+  void IntegerSelected();
+  void AddInteger();
+  void RemoveInteger();
+private:
+  QBoxLayout *parent;
+  QBoxLayout *thisLayout;
+  QLabel *titleLabel;
+
+  QtQueryListPipe<unsigned int> *pipe;
+};
+
+
 class QtDialog::VectorQtQuery : public Dialog::VectorQuery {
 public:
Index: src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp
===================================================================
--- src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
+++ src/UIElements/Qt4/Query/UnsignedIntsQtQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -0,0 +1,78 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UnsignedIntsQtQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include <Qt/qboxlayout.h>
+#include <Qt/qlabel.h>
+#include <Qt/qlineedit.h>
+#include <Qt/qlistwidget.h>
+#include <Qt/qpushbutton.h>
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "UIElements/Qt4/Query/QtQuery.hpp"
+#include "UIElements/Qt4/Pipe/QtQueryListPipe.hpp"
+
+
+QtDialog::UnsignedIntsQtQuery::UnsignedIntsQtQuery(string _title,QBoxLayout *_parent,QtDialog *_dialog) :
+    Dialog::UnsignedIntsQuery(_title),
+    parent(_parent)
+{
+  QHBoxLayout * thisHLayout = new QHBoxLayout();
+  QVBoxLayout * thisV1Layout = new QVBoxLayout();
+  QVBoxLayout * thisV2Layout = new QVBoxLayout();
+
+  QLabel *titleLabel = new QLabel(QString(getTitle().c_str()));
+  QLabel *inputLabel = new QLabel("Enter to add");
+  QListWidget* inputList = new QListWidget();
+  inputList->setSelectionMode(QAbstractItemView::ExtendedSelection);
+  QLineEdit* inputBox = new QLineEdit();
+  inputLabel->setBuddy(inputBox);
+  titleLabel->setBuddy(inputList);
+  QPushButton* AddButton = new QPushButton("Add");
+  AddButton->setEnabled(false);
+  QPushButton* RemoveButton = new QPushButton("Remove");
+  RemoveButton->setEnabled(false);
+
+  thisV1Layout->addWidget(titleLabel);
+  thisV1Layout->addWidget(inputList);
+  thisV2Layout->addWidget(inputLabel);
+  thisV2Layout->addWidget(inputBox);
+  thisV2Layout->addWidget(AddButton);
+  thisV2Layout->addWidget(RemoveButton);
+  parent->addLayout(thisHLayout);
+  thisHLayout->addLayout(thisV1Layout);
+  thisHLayout->addLayout(thisV2Layout);
+
+  pipe = new QtQueryListPipe<unsigned int>(&tmp,_dialog,inputBox,inputList,AddButton,RemoveButton);
+  connect(inputBox,SIGNAL(textChanged(const QString&)),pipe,SLOT(IntegerEntered(const QString&)));
+  connect(inputList,SIGNAL(itemSelectionChanged()),pipe,SLOT(IntegerSelected()));
+  connect(AddButton,SIGNAL(Clicked()),pipe,SLOT(AddValue()));
+  connect(RemoveButton,SIGNAL(Clicked()),pipe,SLOT(RemoveRow()));
+}
+
+QtDialog::UnsignedIntsQtQuery::~UnsignedIntsQtQuery()
+{
+  delete pipe;
+}
+
+bool QtDialog::UnsignedIntsQtQuery::handle() {
+  return true;
+}
+
+
Index: src/UIElements/Query/UnsignedIntsQuery.cpp
===================================================================
--- src/UIElements/Query/UnsignedIntsQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
+++ src/UIElements/Query/UnsignedIntsQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -0,0 +1,35 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UnsignedIntsQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include "Dialog.hpp"
+#include "Actions/ValueStorage.hpp"
+
+
+// UnsignedInts Queries
+Dialog::UnsignedIntsQuery::UnsignedIntsQuery(string title, std::string description) :
+    Query(title, description)
+{}
+
+Dialog::UnsignedIntsQuery::~UnsignedIntsQuery() {}
+
+void Dialog::UnsignedIntsQuery::setResult() {
+  ValueStorage::getInstance().setCurrentValue(title.c_str(), tmp);
+}
+
Index: src/UIElements/TextUI/Query/TextQuery.hpp
===================================================================
--- src/UIElements/TextUI/Query/TextQuery.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/TextUI/Query/TextQuery.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -136,4 +136,11 @@
 };
 
+class TextDialog::UnsignedIntsTextQuery : public Dialog::UnsignedIntsQuery {
+public:
+  UnsignedIntsTextQuery(std::string title, std::string _description = NULL);
+  virtual ~UnsignedIntsTextQuery();
+  virtual bool handle();
+};
+
 class TextDialog::VectorTextQuery : public Dialog::VectorQuery {
 public:
Index: src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp
===================================================================
--- src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
+++ src/UIElements/TextUI/Query/UnsignedIntsTextQuery.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -0,0 +1,58 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
+/*
+ * UnsignedIntsTextQuery.cpp
+ *
+ *  Created on: Oct 25, 2010
+ *      Author: heber
+ */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
+
+#include "CodePatterns/MemDebug.hpp"
+
+#include <iostream>
+
+#include "TextUI/Query/TextQuery.hpp"
+
+#include "CodePatterns/Log.hpp"
+#include "CodePatterns/Verbose.hpp"
+
+
+TextDialog::UnsignedIntsTextQuery::UnsignedIntsTextQuery(string title, std::string _description) :
+    Dialog::UnsignedIntsQuery(title,_description)
+{}
+
+TextDialog::UnsignedIntsTextQuery::~UnsignedIntsTextQuery() {}
+
+bool TextDialog::UnsignedIntsTextQuery::handle() {
+  std::cout << getDescription() << ": ";
+  std::string line;
+  getline(std::cin,line);
+  // dissect by " "
+  std::string::iterator olditer = line.begin();
+  for(string::iterator iter = line.begin(); iter != line.end(); ++iter) {
+    if (*iter == ' ') {
+      std::istringstream stream(string(iter, olditer));
+      stream >> temp;
+      tmp.push_back(temp);
+      olditer = iter;
+    }
+  }
+  if (olditer != line.begin()) { // insert last part also
+    std::istringstream stream(string(olditer, line.end()));
+    stream >> temp;
+    tmp.push_back(temp);
+  }
+
+  return true;
+}
+
Index: src/UIElements/TextUI/TextDialog.cpp
===================================================================
--- src/UIElements/TextUI/TextDialog.cpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/TextUI/TextDialog.cpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -52,4 +52,8 @@
 void TextDialog::queryUnsignedInt(const char* title, std::string description){
   registerQuery(new UnsignedIntTextQuery(title,description));
+}
+
+void TextDialog::queryUnsignedInts(const char* title, std::string description){
+  registerQuery(new UnsignedIntsTextQuery(title,description));
 }
 
Index: src/UIElements/TextUI/TextDialog.hpp
===================================================================
--- src/UIElements/TextUI/TextDialog.hpp	(revision 838cd09f5b0b8fc58fc121f2fad94ab4a811175b)
+++ src/UIElements/TextUI/TextDialog.hpp	(revision 12948c2ccfa9172ddcc2b58e9905c238b969ea5d)
@@ -35,4 +35,5 @@
   virtual void queryInts(const char *, std::string = "");
   virtual void queryUnsignedInt(const char *, std::string = "");
+  virtual void queryUnsignedInts(const char *, std::string = "");
   virtual void queryString(const char*, std::string = "");
   virtual void queryStrings(const char*, std::string = "");
@@ -72,4 +73,5 @@
   class StringsTextQuery;
   class UnsignedIntTextQuery;
+  class UnsignedIntsTextQuery;
   class VectorTextQuery;
   class VectorsTextQuery;