Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-addingjobs.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -15,5 +15,5 @@
 
 # add one jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "cat" "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
@@ -27,5 +27,5 @@
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-checkstate.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -14,9 +14,9 @@
 
 # check jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-completerun.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -15,13 +15,13 @@
 
 # add two jobs via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "cat" "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "cat" "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "cat" "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # Checking results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "#3 are waiting in the queue and #0 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
@@ -35,9 +35,9 @@
 
 # Checking results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep "#0 are waiting in the queue and #3 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # get results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep "Received 3 results" stdout], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([fgrep -c "Nothing" stdout], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
@@ -45,9 +45,9 @@
 
 # get no more results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 AT_CHECK([grep "Nothing" stdout], 1, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-enrollinpool.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -25,5 +25,5 @@
 
 # shutdown server as well
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
 # check that Server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-getresults.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -14,9 +14,9 @@
 
 # directly obtain 0 results
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT receiveresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receiveresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "RESULT" stdout], 1, [stdout], [ignore], [kill $server_pid])
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-mpqc-jobs.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -25,5 +25,5 @@
 
 # add jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT addjobs "../../mpqc" Job??.in], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command addjobs --executable "../../mpqc" --jobfiles Job??.in], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
@@ -32,9 +32,9 @@
 AT_CHECK([sleep 5], 0, [ignore], [ignore], [kill $server_pid $worker_pid])
 
-# send kill signal to worker such that it shuts down
-AT_CHECK([kill -INT $worker_pid], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
+# send removeall to server such that all workers shutdown
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command removeall], 0, [stdout], [ignore], [kill $server_pid $worker_pid])
 
 # check number of done jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT receivempqc ${abs_top_srcdir}/tests/regression/Fragmentation/Automation/pre/], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command receivempqc --fragment-path ${abs_top_srcdir}/tests/regression/Fragmentation/Automation/pre/], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "There are 7 fragments" stdout], 0, [ignore], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "There are 23 atoms" stdout], 0, [ignore], [ignore], [kill $server_pid])
@@ -43,5 +43,5 @@
 
 # shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-resubmitjobs.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -15,5 +15,5 @@
 
 # add one always failing job via JobAdder
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "/bin/false" "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "/bin/false" --jobcommand "Nothing"], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "Sending 1 jobs ..." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
@@ -31,5 +31,5 @@
 
 # shutdown
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [ignore], [ignore], [kill $server_pid] $worker_pid)
 
 # check that server is truely down
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-shutdown.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -14,5 +14,5 @@
 
 # shutdown server again
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([grep "Operation completed." stdout], 0, [stdout], [ignore], [kill $server_pid])
 
Index: tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at
===================================================================
--- tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 684bc115d868b72f2c94303c9ebeab68f5c4b75e)
+++ tests/regression/Fragmentation/Automation/testsuite-fragmentation-automation-server-worker.at	(revision 17017ba23edbf313cf0a6d860e5d06ea726b2b6a)
@@ -15,5 +15,5 @@
 
 # add one jobs 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT createjobs "cat" "Nothing"], 0, [ignore], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command createjobs --executable "cat" --jobcommand "Nothing"], 0, [ignore], [ignore], [kill $server_pid])
 
 # enlist a worker to work on jobs
@@ -26,9 +26,9 @@
 
 # check number of done jobs
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT checkresults], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command checkresults], 0, [stdout], [ignore], [kill $server_pid])
 AT_CHECK([fgrep "#0 are waiting in the queue and #1 jobs are calculated so far." stdout], 0, [ignore], [ignore], [kill $server_pid])
 
 # shutdown controller socket 
-AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller 127.0.0.1 $CONTROLLERPORT shutdown], 0, [stdout], [ignore], [kill $server_pid])
+AT_CHECK([${AUTOTEST_PATH}/Fragmentation/Automation/Controller --server 127.0.0.1:$CONTROLLERPORT --command shutdown], 0, [stdout], [ignore], [kill $server_pid])
 
 # check that server is truely down